local BOHCB, LDB = unpack(Broker_OrderHallCommandBar)
local BarToggle = BOHCB:NewDataObject("launcher", "Command Bar Toggle")

function BarToggle:OnInitialize()
    local _, class = UnitClass("player")
    self.icon = "Interface\\TargetingFrame\\UI-Classes-Circles"
    self.iconCoords = CLASS_ICON_TCOORDS[strupper(class)]
    self.text = _G["ORDER_HALL_"..class]
end

function BarToggle:OnClick()
    local inOrderHall = C_Garrison.IsPlayerInGarrison(Enum.GarrisonType.Type_7_0)
    if inOrderHall and OrderHallCommandBar then
        if OrderHallCommandBar:IsShown() then
            OrderHallCommandBar:Hide()
        else
            BOHCB.ShowBar = true
            OrderHallCommandBar:Show()
        end
    end
end

function BarToggle:OnTooltipShow()
    self:AddLine(BarToggle.text, 1, 1, 1, true)
    self:AddLine(SHOW .. "/" .. HIDE)
end
