local BOHCB, LDB = unpack(Broker_OrderHallCommandBar)
local TroopsObject = LibStub("AceEvent-3.0"):Embed(BOHCB:NewDataObject("data source", "Troops"))

local categoryInfo
local categoryInfoCount

local function Update()
    categoryInfo = C_Garrison.GetClassSpecCategoryInfo(Enum.GarrisonFollowerType.FollowerType_7_0)
    categoryInfoCount = 0
    
    local count, limit = 0, 0
    for _, category in ipairs(categoryInfo) do
        if category.count and category.limit then
            count = count + category.count
            limit = limit + category.limit
        end
        categoryInfoCount = categoryInfoCount + 1
    end

    TroopsObject.text = format(ORDER_HALL_COMMANDBAR_CATEGORY_COUNT, count, limit)
end

function TroopsObject:OnInitialize()
    TroopsObject.icon = "Interface\\Garrison\\Portraits\\FollowerPortrait_NoPortrait"

    self:RegisterEvent("PLAYER_ENTERING_WORLD", Update)
    self:RegisterEvent("UNIT_AURA", Update)
    self:RegisterEvent("GARRISON_FOLLOWER_CATEGORIES_UPDATED", Update)
    self:RegisterEvent("GARRISON_FOLLOWER_ADDED", Update)
    self:RegisterEvent("GARRISON_FOLLOWER_REMOVED", Update)

    Update()
end

function TroopsObject.OnTooltipShow(tooltip)
	tooltip:SetText(FOLLOWERLIST_LABEL_TROOPS, 1, 1, 1)
    local count = 0
    for _, category in pairs(categoryInfo) do
        local title = format("|T%1$s:16:16|t %2$s", category.icon, category.name)
        if category.count and category.limit then
            title = title .. " " .. format(ORDER_HALL_COMMANDBAR_CATEGORY_COUNT, category.count, category.limit)
        end
        tooltip:AddLine(title)
        if category.description then
            tooltip:AddLine(category.description, 1, 1, 1, true)
        end
        count = count + 1
        if count < categoryInfoCount then
            tooltip:AddLine(" ")
        end
    end    
end
